/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2017 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.client.render.entitys;

import net.minecraft.client.Minecraft;
import net.minecraft.client.renderer.BlockRendererDispatcher;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.client.renderer.entity.Render;
import net.minecraft.client.renderer.entity.RenderManager;
import net.minecraft.client.renderer.texture.TextureMap;
import net.minecraft.util.ResourceLocation;
import net.minecraft.util.math.MathHelper;
import techreborn.blocks.BlockNuke;
import techreborn.entitys.EntityNukePrimed;
import techreborn.init.ModBlocks;

/**
 * Created by Mark on 13/03/2016.
 */
public class RenderNukePrimed extends Render<EntityNukePrimed> {

	public RenderNukePrimed(RenderManager renderManager) {
		super(renderManager);
		this.field_76989_e = 0.5F;
	}

	@Override
	public void func_76986_a(EntityNukePrimed entity, double x, double y, double z, float entityYaw, float partialTicks) {
		BlockRendererDispatcher blockrendererdispatcher = Minecraft.func_71410_x().func_175602_ab();
		GlStateManager.func_179094_E();
		GlStateManager.func_179109_b((float) x, (float) y + 0.5F, (float) z);
		if ((float) entity.fuse - partialTicks + 1.0F < 10.0F) {
			float f = 1.0F - ((float) entity.fuse - partialTicks + 1.0F) / 10.0F;
			f = MathHelper.func_76131_a(f, 0.0F, 1.0F);
			f = f * f;
			f = f * f;
			float f1 = 1.0F + f * 0.3F;
			GlStateManager.func_179152_a(f1, f1, f1);
		}
		float f2 = (1.0F - ((float) entity.fuse - partialTicks + 1.0F) / 100.0F) * 0.8F;
		this.func_180548_c(entity);
		GlStateManager.func_179109_b(-0.5F, -0.5F, 0.5F);
		blockrendererdispatcher.func_175016_a(ModBlocks.NUKE.func_176223_P(),
			entity.func_70013_c(partialTicks));
		GlStateManager.func_179109_b(0.0F, 0.0F, 1.0F);
		if (entity.fuse / 5 % 2 == 0) {
			GlStateManager.func_179140_f();
			GlStateManager.func_179147_l();
			GlStateManager.func_179112_b(770, 772);
			GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1F);
			GlStateManager.func_179136_a(-3.0F, -3.0F);
			GlStateManager.func_179088_q();
			blockrendererdispatcher.func_175016_a(
				ModBlocks.NUKE.func_176223_P().func_177226_a(BlockNuke.OVERLAY, true), 1.0F);
			GlStateManager.func_179136_a(0.0F, 0.0F);
			GlStateManager.func_179113_r();
			GlStateManager.func_179131_c(1.0F, 1.0F, 1.0F, 1.0F);
			GlStateManager.func_179084_k();
			GlStateManager.func_179145_e();
		}
		GlStateManager.func_179121_F();
		super.func_76986_a(entity, x, y, z, entityYaw, partialTicks);
	}

	@Override
	protected ResourceLocation func_110775_a(EntityNukePrimed entity) {
		return TextureMap.field_110575_b;
	}
}
