/*
 * This file is part of TechReborn, licensed under the MIT License (MIT).
 *
 * Copyright (c) 2017 TechReborn
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package techreborn.items.tools;

import com.google.common.collect.Sets;
import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.block.state.IBlockState;
import net.minecraft.init.Blocks;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemTool;
import reborncore.RebornCore;
import techreborn.client.TechRebornCreativeTabMisc;

import java.util.Set;

import net.minecraft.item.Item.ToolMaterial;

public class ItemTRAxe extends ItemTool {
	private static final Set<Block> EFFECTIVE_ON = Sets.newHashSet(new Block[] { Blocks.field_150344_f, Blocks.field_150342_X,
		Blocks.field_150364_r, Blocks.field_150363_s, Blocks.field_150486_ae, Blocks.field_150423_aK, Blocks.field_150428_aP, Blocks.field_150440_ba,
		Blocks.field_150468_ap, Blocks.field_150471_bO, Blocks.field_150452_aw });
	private ToolMaterial material = ToolMaterial.WOOD;

	public ItemTRAxe(ToolMaterial material) {
		super(material, EFFECTIVE_ON);
		this.field_77865_bY = material.func_78000_c() + 5.75F;
		this.field_185065_c = (material.func_78000_c() + 6.75F) * -0.344444F;
		func_77655_b(material.name().toLowerCase() + "Axe");
		func_77637_a(TechRebornCreativeTabMisc.instance);
		this.material = material;
	}

	public float func_150893_a(ItemStack stack, IBlockState state) {
		Material material = state.func_185904_a();
		return material != Material.field_151575_d && material != Material.field_151585_k && material != Material.field_151582_l
		       ? super.func_150893_a(stack, state) : this.field_77864_a;
	}
}
